/*  -------------------------------------------------------------------

    TOS Vs 1.0  11-28-85   Toshiba Printer Control

    By        Stewart Hyde
    Contact   PC-EXCHANGE  Atlanta Ga (404) 977-6686

    This is the source to TOS which was compiled by Microsoft C 3.0
    Compiler.  The following code is public domain with the
    following restrictions:

            1.  Modify Version not from author may not be
                distributive.
            2.  Since source has been given, you may not delete
                the first 25 lines from the source. (i.e the
                first set of comments)
            3.  Author makes no claims on operation of program
                and Users should be aware that side effects from
                user modifications of this program is not the
                author's problem.
            4.  Please give this code to others and review the
                source code for educational pleasure.


    -------------------------------------------------------------------  */

#include <stdio.h>
#include <process.h>
#include <dos.h>

#define MSC          'Include This Line if using Microsoft C Vs 3.0'

#define FnLocate(x)  Locate(3*((x-1)/2)+5+((x-1) % 2),15)
#define Print(x)     putc(x,stdprn)

#define ESC          '\x1B'
#define SUB          '\x1A'
#define UR           '\xBB'
#define UL           '\xC9'
#define LR           '\xBC'
#define LL           '\xC8'
#define MR           '\xB9'
#define ML           '\xCC'
#define SIDE         '\xBA'
#define BAR          '\xCD'
#define SPACE        '\x20'

#define VIDEO_IO     0x10

/* ------------------------------------------------------------------
   ClearWindow(y1,x1,y2,x2) - Clears a window on screen with Upper
                              left corner (y1,x1) and lower right
                              corner (y2,x2).  Use INT 16 Video to
                              clear the screen.
   ------------------------------------------------------------------ */


void ClearWindow(y1,x1,y2,x2)
unsigned y1,x1,y2,x2;
{
      union REGS regs;

      regs.h.ah = 6;                      /*   Scroll Window Up      */
      regs.h.al = 0;                      /*   Clear Window          */
      regs.h.ch = y1;
      regs.h.cl = x1;
      regs.h.dh = y2;
      regs.h.dl = x2;
      regs.h.bh = 7;                      /*   Attribute             */
      int86(VIDEO_IO,&regs,&regs);
}

/* ------------------------------------------------------------------
   Locate (y,x) - Set the cursor to (y,x) by using INT 16
   ------------------------------------------------------------------ */

void Locate(y,x)
unsigned y,x;
{
      union REGS regs;

      regs.h.ah = 2;                         /*  Set Cursor          */
      regs.h.bh = 0;
      regs.h.dh = y;
      regs.h.dl = x;
      int86(VIDEO_IO,&regs,&regs);
}

/* ------------------------------------------------------------------
   Cls - Clears the screen by calling ClearWindow with cordinates of
         full screen and then position cursor at top left with
         Locate.
   ------------------------------------------------------------------ */

void Cls()
{
      ClearWindow(0,0,24,79);
      Locate(0,0);
}

/* ------------------------------------------------------------------
   PrintLine (c,n) - prints character c  n times on the screen.
   ------------------------------------------------------------------ */


void PrintLine(c,n)
char       c;
unsigned   n;
{
      register int i;

      for (i=1;i<=n;i++)
          putch(c);
}

/* ------------------------------------------------------------------
   InitScreenTos - Clears the screen and draws borders around screen.
                   Menu is drawn seperately for future help screen.
   ------------------------------------------------------------------ */


InitScreenTos()
{
      register  int i;

      Cls();
      putch(UL);
      PrintLine(BAR,78);
      putch(UR);
      putch(SIDE);
      PrintLine(SPACE,78);
      putch(SIDE);
      putch(ML);
      PrintLine(BAR,78);
      putch(MR);
      for (i=3;i<23;i++)
      {
             putch(SIDE);
             PrintLine(SPACE,78);
             putch(SIDE);
      }
      putch(LL);
      PrintLine(BAR,78);
      putch(LR);
      Locate(24,1);
      printf("Toshiba 351 Printer Control");
      Locate(24,45);
      printf("Public Domain By Stewart Hyde 1985");
      Locate(1,15);
      printf("Toshiba 351 Printer Control - Select Desired Option");
}

/* ------------------------------------------------------------------
   DisplayTosMenu - Diplays the menu and sets cursor indicated to
                    first option.
   ------------------------------------------------------------------ */


DisplayTosMenu()
{
      Locate(5,20);
      printf("<F1>  - 12 CPI Elite Font Letter Quality Mode");
      Locate(6,20);
      printf("<F2>  - 10 CPI Elite Font Letter Quality Mode");
      Locate(8,20);
      printf("<F3>  - 12 CPI Courier Font Letter Quality Mode");
      Locate(9,20);
      printf("<F4>  - 10 CPI Courier Font Letter Quality Mode");
      Locate(11,20);
      printf("<F5>  - 12 CPI High Speed Data Processing Mode");
      Locate(12,20);
      printf("<F6>  - 10 CPI High Speed Data Processing Mode");
      Locate(14,20);
      printf("<F7>  - 20 CPI Compressed Print Mode");
      Locate(15,20);
      printf("<F8>  - 17 CPI Compressed Print Mode\n");
      Locate(17,20);
      printf("<F9>  - Exit Programs with no changes");
      Locate(5,15);
      printf("-->");
}

/* ------------------------------------------------------------------
   GetFn (f) - Gets menu item for menu.  User may use Function keys,
               Cursor keys, Home send you to the first option and
               End sends you to last option.  Use enter to execute
               option and leave.
   ------------------------------------------------------------------ */


int GetFn(f)
int f;
{
     register  int  x, Key;

     do      {
             Key = 0;
             if ((x = getch()) == 0)
                    Key = getch();
             if ((Key > 58) && (Key < 68))
                    Key -= 58;
             if ((Key == 71) || (Key == 73))
                    Key = 1;
             if ((Key == 79) || (Key == 81))
                    Key = 9;
             if (Key == 72)
                    {
                           Key = f - 1;
                           if (Key < 1)
                                  Key = 9;
                    }
             if (Key == 80)
                    {
                          Key = f + 1;
                          if (Key > 9)
                                  Key = 1;
                    };
            if ((Key > 0) && (Key < 10))
                    {
                           FnLocate(f);
                           printf("   ");
                           FnLocate(Key);
                           printf("-->");
                           f = Key;
                    };
     }       while (x != 13);
     return(f);
}

/* ------------------------------------------------------------------
   printcode - use to optimize ExecFn in printing codes to Toshiba
               This technique is being use because of redundancy in
               the Toshiba Printer commands being use in this utility.
   ------------------------------------------------------------------ */


printcode(a,b)
int   a, b;
{
      Print(ESC);
      Print('*');
      Print(a);
      Print(ESC);
      Print('E');
      Print('1');
      Print(b);
}

/* ------------------------------------------------------------------
   ExecFn (f) -  Executes option f from menu selection.
   ------------------------------------------------------------------ */


ExecFn(f)
int f;
{
      switch (f) {
      case 1:
             printcode('1','0');
             break;
      case 2:
             printcode('1','2');
             break;
      case 3:
             printcode('2','0');
             break;
      case 4:
             printcode('2','2');
             break;
      case 5:
             printcode('0','0');
             break;
      case 6:
             printcode('0','2');
             break;
      case 7:
             printcode('0','0');
             Print(ESC);
             Print('[');
             break;
      case 8:
             printcode('0','2');
             Print(ESC);
             Print(']');
             break;
      default:
             break;
     }
}

/* ------------------------------------------------------------------
   main - This is the main routine which draws the menus, allows the
          user to select the option , executes the option and leaves
          the program.
   ------------------------------------------------------------------ */


main()
{
      int Fn = 1;


      InitScreenTos();
      DisplayTosMenu();
      Fn = GetFn(Fn);
      ExecFn(Fn);
      Cls();
      printf("TOS Version VS 1.0    11/28/85    ");
      printf("Public Domain By Stewart Hyde 1985");
}
